import json
import sys

from core.config import get_parser, params_check


def get_fparser():
    parser = get_parser()
    parser.add_argument("--config", default=None, type=str, help="model configuration")
    return parser


parser = get_fparser()
args = parser.parse_args()
if args.config is not None:
    config_args = json.load(open(args.config))
    override_keys = {
        arg[2:].split("=")[0] for arg in sys.argv[1:] if arg.startswith("--")
    }
    for k, v in config_args.items():
        if k not in override_keys:
            setattr(args, k, v)
del args.config
params_check(args)
